from cpl_query.extension import List

from bot_api.api_module import ApiModule
from bot_core.core_extension.core_extension_module import CoreExtensionModule
from bot_core.core_module import CoreModule
from bot_data.data_module import DataModule
from bot_graphql.graphql_module import GraphQLModule
from modules.achievements.achievements_module import AchievementsModule
from modules.auto_role.auto_role_module import AutoRoleModule
from modules.base.base_module import BaseModule
from modules.boot_log.boot_log_module import BootLogModule
from modules.database.database_module import DatabaseModule
from modules.level.level_module import LevelModule
from modules.permission.permission_module import PermissionModule
from modules.technician.technician_module import TechnicianModule


class ModuleList:
    @staticmethod
    def get_modules():
        # core modules (modules out of modules folder) should be loaded first!
        return List(
            type,
            [
                CoreModule,  # has to be first!
                DataModule,
                GraphQLModule,
                PermissionModule,
                DatabaseModule,
                AutoRoleModule,
                BaseModule,
                LevelModule,
                ApiModule,
                TechnicianModule,
                AchievementsModule,
                # has to be last!
                BootLogModule,
                CoreExtensionModule,
            ],
        )
