from bot_core.logging.database_logger import DatabaseLogger
from bot_data.abc.migration_abc import MigrationABC
from bot_data.db_context import DBContext


class UserMessageCountPerHourMigration(MigrationABC):
    name = "0.3.1_UserMessageCountPerHourMigration"

    def __init__(self, logger: DatabaseLogger, db: DBContext):
        MigrationABC.__init__(self)
        self._logger = logger
        self._db = db
        self._cursor = db.cursor

    def upgrade(self):
        self._logger.debug(__name__, "Running upgrade")

        self._cursor.execute(
            str(
                f"""
            CREATE TABLE IF NOT EXISTS `UserMessageCountPerHour` (
                `Id` BIGINT NOT NULL AUTO_INCREMENT,
                `Date` DATETIME(6) NOT NULL,
                `Hour` BIGINT,
                `XPCount` BIGINT,
                `UserId` BIGINT,
                `CreatedAt` DATETIME(6),
                `LastModifiedAt` DATETIME(6),
                PRIMARY KEY(`Id`),
                FOREIGN KEY (`UserId`) REFERENCES `Users`(`UserId`)
            );
            """
            )
        )

    def downgrade(self):
        self._cursor.execute("DROP TABLE `UserMessageCountPerHour`;")
