from bot_data.model.server import Server
from bot_graphql.abc.history_query_abc import HistoryQueryABC


class ServerHistoryQuery(HistoryQueryABC):
    def __init__(
        self,
    ):
        HistoryQueryABC.__init__(self, "Server")

        self.set_field("id", self.resolve_id)
        self.set_field("discordId", self.resolve_discord_id)
        self.set_field("name", self.resolve_name)
        self.set_field("iconURL", self.resolve_icon_url)

    @staticmethod
    def resolve_id(server: Server, *_):
        return server.id

    @staticmethod
    def resolve_discord_id(server: Server, *_):
        return server.discord_id

    @staticmethod
    def resolve_name(server: Server, *_):
        return server.name

    @staticmethod
    def resolve_icon_url(server: Server, *_):
        return server.icon_url
